---
name: 🐞 Bug Fix
about: You have a fix for a bug?
labels: bug

---

## A Pull Request should be associated with an Issue.

> If you're offering a new feature or fixing anything, please provide the details in Issues,
> so that the development can be pointed in the intended direction.

Related issue: <!-- Please link the related issue -->

> Further notes in [Contribution Guidelines](.github/CONTRIBUTING.md)
> Thank you for your contribution.

### Description

This PR [briefly explain what it does]

> In case this PR introduced TypeScript/JavaScript code changes:

- [ ] I have written test cases for the changes in this pull request.
- [ ] I have run `npm run format` before the commit.
- [ ] I have run `npm run lint` before the commit.
- [ ] I have run `npm run release` before the commit.
- [ ] `npm test` returns with no unit test errors and all code covered.

> In case this PR edits any scripts:

- [ ] I have checked the edited scripts for syntax.
- [ ] I have tested the changes in an integration test (If yes, provide workflow link).

<!--
- Please target the develop branch when submitting the pull request.
-->
